module 'data.record' {
   /** {} = Record.
    *  Returns an empty record.
    */

   {} = Record :-
      'kernel':record_new(X),
      module Record [Record, X] {
         {}.

         {[]}.

         {A . B} :-
            Record:(
               {A},
               {B}
            ).

         {A, B} :-
            Record:(
               {A},
               {B}
            ).

         {Key => Value} :-
            Record:{Key} = Value.

         {Key} = Value :-
            'kernel':record_get(X, Key, Value).

         keys(List) :-
            'kernel':record_keys(X, List).

         iter(F) :-
            module F0 [Record, F] {
               do(Key) :-
                  F:do(Key, Record:{Key}).
            },
            'data.list':iter(Record:keys, F0).

         list(List) :-
            module F [Record] {
               do(Key) = (Key => Record:{Key}).
            },
            'data.list':iter(Record:keys, F, List).

         copy = 'data.record':{Record:list}.

         pretty = '\'data.record\':'({ Record:list }).
      }.

   /** { Initial_contents } = Record.
    *  Returns an empty record.
    */

   {Initial_contents} = Record :-
      Record = 'data.record':{},
      Record:{Initial_contents}.
}
