module 'data.term' {
   check(X) :-
      'kernel':term_check(X).

   compare(A, B, R) :-
      'kernel':term_compare(A, B, R).

   A >= B :-
      'kernel':term_ge(A, B).

   A > B :-
      'kernel':term_gt(A, B).

   A =< B :-
      'kernel':term_le(A, B).

   A < B :-
      'kernel':term_lt(A, B).

   decomposition(Term, List) :-
      'kernel':term_decomposition(Term, List).

   make(F, Args, Term) :-
      'data.term':decomposition(Term, [F | Args]).

   functor(Term, F, N) :-
      'kernel':term_functor(Term, F, N).

   new(F, N, Term) :-
      'data.term':functor(Term, F, N).
}
