module 'emop.compile' {
   test(Modules, Output) :-
      module MakeInitCall {
         do(_, ModList, InitGoal) :-
            InitPos = callable(initialization, []),
            'data.list':length(ModList, Count),
            ExceptionVarCounter = 'data.ref.backtrackable':new(0),
            InitGoal0 =
               'emop.writer':callable(
                  g_assign(
                     'emop.writer':callable('success_test_count'), number(0)
                  )
               ),
            (InitGoal1, _) =
               'data.list':fold_left(ModList, (InitGoal0, 0)) [
                  InitPos, Count, ExceptionVarCounter
               ] {
                  do((_, ModId), (OldInitGoal, Index)) =
                     (NewInitGoal, 'data.number':succ(Index))
                  :-
                     Exception =
                        'data.atom':format(
                           'E_~d', ['data.number':(ExceptionVarCounter++)]
                        ),
                     NewInitGoal = 'emop.writer':sequence(
                        [
                           OldInitGoal,
                           'emop.writer':callable(
                              print(
                                 'emop.writer':callable(
                                    'data.atom':format(
                                       'Testing \'~a\' (~d/~d)... ',
                                       [ModId, Index, Count]
                                    )
                                 )
                              )
                           ),
                           'emop.writer':callable(flush_output),
                           'emop.writer':callable(
                              catch(
                                 'emop.writer':condition(
                                    'emop.writer':callable(
                                       emop_call(
                                          'emop.writer':callable(ModId),
                                          'emop.writer':callable('test'),
                                          'emop.writer':callable(InitPos)
                                       )
                                    ),
                                    'emop.writer':sequence(
                                       [
                                          'emop.writer':callable(
                                             print(
                                                'emop.writer':callable('succeed.\n')
                                             )
                                          ),
                                          'emop.writer':callable(
                                             g_inc(
                                                'emop.writer':callable('success_test_count'),
                                                var('_'),
                                                var('_')
                                             )
                                          )
                                       ]
                                    ),
                                    'emop.writer':callable(
                                       print('emop.writer':callable('failed.\n'))
                                    )
                                 ),
                                 var(Exception),
                                 'emop.writer':sequence(
                                    [
                                       'emop.writer':callable(
                                          print('emop.writer':callable('exception: '))
                                       ),
                                       'emop.writer':callable(
                                          print(var(Exception))
                                       ),
                                       'emop.writer':callable(
                                          print('emop.writer':callable('.\n'))
                                       )
                                    ]
                                 )
                              )
                           )
                        ]
                     )
               },
            InitGoal =
               'emop.writer':sequence(
                  [
                     InitGoal1,
                     'emop.writer':callable(
                        g_read(
                           'emop.writer':callable('success_test_count'),
                           var(SuccessCount)
                        )
                     ),
                     'emop.writer':callable(print(var(SuccessCount))),
                     'emop.writer':callable(
                        print(
                           'data.atom':format(
                              '/~d tests passed.',
                              [Count]
                           )
                        )
                     )
                  ]
               ).
      },
      compile(Modules, BaseFilename, FilenamePl, MakeInitCall),
      (
         Output = 'atom.concat'(BaseFilename, '.test')
      ->
         true
      ;
         true
      ),
      link(Output, [FilenamePl]).
      

   build(Modules, Output) :-
      module MakeInitCall {
         do(MainModId, _) =
            callable(
               emop_call,
               [
                  callable(MainModId, []),
                  callable(main, []),
                  callable(initialization, [])
               ]
            ).
      },
      compile(Modules, BaseFilename, FilenamePl, MakeInitCall),
      (
         Output = BaseFilename
      ->
         true
      ;
         true
      ),
      link(Output, [FilenamePl]).

   link(Output, PrologFiles) :-
      (
         'sys.process':spawn(
            'gplc',
            [
               '--no-top-level',
               '--local-size',
               '70000',
               '--global-size',
               '70000',
               '-o',
               Output
            |
               PrologFiles
            ]
         )
      ->
         true
      ;
         throw(error('Linking failed', cmdline))
      ).


   compile(Modules, BaseFilename, Output, MakeInitCall) :-
      'data.ref.non_backtrackable':(
         new(none, MainModRef),
         new([], IncludedRef),
         new([], QueuedRef),
         new(callable(true, []), InitRef),
         new([], ClausesRef)
      ),
      module Compiler [
         Compiler,
         MainModRef,
         IncludedRef,
         QueuedRef,
         InitRef,
         ClausesRef,
         PackageNodes,
         RootPackagePath,
         MakeInitCall
      ] {
         queue(ModSpec, Pos) :-
            QueuedRef:get(Queued),
            QueuedRef:set([(ModSpec, Pos) | Queued]).

         dequeue(ModSpec, Pos) :-
            QueuedRef:get([(ModSpec, Pos) | QueuedTail]),
            QueuedRef:set(QueuedTail).

         compile_all :-
            (
               repeat,
               (
                  Compiler:dequeue(ModId, Pos)
               ->
                  (
                     Compiler:compile(ModId, Pos)
                  ->
                     fail
                  ;
                     throw('big problem')
                  )
               ;
                  true
               )
            ->
               true
            ).

         generate_pl(BaseFilename, FilenamePl) :-
            (
               MainModRef:get(some(MainModId, BaseFilename))
            ->
               true
            ;
               throw(error('No module to build', cmdline))
            ),
            InitRef:get(Init),
            ClausesRef:get(Clauses),
            EmopCallArgs = [var(mod), var(call), var(pos)],
            IsModVar = callable('var', [var(mod)]),
            EmopFunc = callable('/', [callable('emop_call', []), number(3)]),
            InstErr0 = callable('instantiation_error', [EmopFunc, var(pos)]),
            InstErr = callable('error', [InstErr0, var(pos)]),
            ThrowInstError = callable('throw', [InstErr]),
            EmopInstErr = callable(',', [IsModVar, ThrowInstError]),
            Uninst = clause('emop_call', 3, EmopCallArgs, EmopInstErr),
            StaticCall = callable('static_emop_call', EmopCallArgs),
            CallChain = clause('emop_call', 3, EmopCallArgs, StaticCall),
            UnkErr0 = callable('unknown_module', [EmopFunc]),
            UnkE = callable('throw', [callable('error', [UnkErr0, var(pos)])]),
            Unk = clause('static_emop_call', 3, EmopCallArgs, UnkE),
            All = 'data.list':append([Uninst, CallChain | Clauses], [Unk]),
            SortedClauses = 'data.list':quick_sort(All) {
               compare(clause(AF, AN, _, _), clause(BF, BN, _, _), R) :-
                  'data.term':compare((AF, AN), (BF, BN), R).
            },
            BuiltClauses = 'data.list':iter(SortedClauses) {
               do(clause(F, _, Args, B), R) :-
                  R = callable(':-', [callable(F, Args), B]).
            },
            InitGoal =
               callable(
                  ',',
                  [Init, MakeInitCall:do(MainModId, IncludedRef:get)]
               ),
            InitDir = callable(':-', [callable('initialization', [InitGoal])]),
            DynamicEmopCall = callable(':-',
            [
               callable(
                  'dynamic',
                  [callable('/', [
                     callable('emop_call', []), number(3)])])]),
            Mod = [InitDir, DynamicEmopCall | BuiltClauses],
            'data.atom':concat(BaseFilename, '.pl', FilenamePl),
            'io.file':open_write(FilenamePl, FilePl),
            (
               'emop.writer':write_clauses(FilePl, Mod)
            ->
               true
            ;
               throw(write(failure))
            ),
            FilePl:close.

         compile(ModSpec, Pos) :-
            'emop.emop':lookup(
               ModSpec,
               Pos,
               BaseFilename,
               FilenameMpl,
               SMpl
            ),
            IncludedRef:get(Included),
            (
               'data.list':member((BaseFilename, Fid), Included)
            ->
               SMpl:close
            ;
               'io.err':(
                  format('Processing \'~a\'...\n', [FilenameMpl]),
                  flush
               ),
               'io.stream':backtrackable(SMpl, Backtrackable),
               'io.stream':text_position(
                  Backtrackable,
                  FilenameMpl,
                  Positionable
               ),
               'emop.lexer':lex(Positionable, Lexems),
               'emop.parser':parse(
                  Lexems,
                  file,
                  Fid,
                  FidPos,
                  Ast0
               ),
               IncludedRef:set([(BaseFilename, Fid) | Included]),
               (
                  Ast0 = callable('.', unescaped, [Ast, empty(Pb, Pe)], _, _)
               ->
                  'emop.message':warning(
                     'Superfluous dot at the end of the file',
                     file(Pb, Pe)
                  )
               ;
                  Ast = Ast0
               ),
               SMpl:close,
               'data.atom':concat(BaseFilename, '.xml', FilenameXml),
               'io.file':open_write(FilenameXml, FileXml),
               FileXml:print_endline('<?xml version="1.0"?>'),
               FileXml:print_endline('<!DOCTYPE file PUBLIC "-//INRIA//DTD EMoP Documentation//EN" "http://contraintes.inria.fr/emop/doc.dtd">'),
               FileXml:print_endline(
                  '<file xmlns="http://contraintes.inria.fr/emop/doc">'
               ),
               (
                  'data.var':check(Fid)
               ->
                  throw(error('No file module', file(FilenameMpl)))
               ;
                  true
               ),
               'data.atom':split(Fid, '.', FidNodes),
               'data.list':append(PackageNodes, [_], FidNodes),
               'data.path':join(PackageNodes, RelRootPackagePath),
               (
                  'data.atom':concat(
                     RootPackagePath,
                     RelRootPackagePath,
                     'data.path':base(BaseFilename)
                  )
               ->
                  true
               ;
                  throw(error('Invalid file module name', FidPos))
               ),
               'emop.expand':expand_file(
                  Fid,
                  FileXml,
                  Ast,
                  Clauses0,
                  Deps,
                  Goal,
                  Expander,
               ),
               Expander:singleton_warning,
               'data.atom':concat(Fid, '@init', InitF),
               Clauses = [clause(InitF, 0, [], Goal) | Clauses0],
               FileXml:print_endline('</file>'),
               FileXml:close,
               'data.list':iter(Deps) [
                  Compiler,
                  PackageNodes,
                  RootPackagePath
               ] {
                  do(dep(Dependency, Pos)) :-
                     Compiler:queue(
                        name(Dependency, PackageNodes, RootPackagePath),
                        Pos
                     ).
               },
               InitRef:get(OtherInit),
               'data.atom':concat(Fid, '@init', InitF),
               InitRef:set(callable(',', [callable(InitF, []), OtherInit])),
               ClausesRef:get(ClausesTail),
               'data.list':reverse_append(Clauses, ClausesTail, All),
               ClausesRef:set(All),
               (
                  MainModRef:get(none)
               ->
                  MainModRef:set(some(Fid, BaseFilename))
               ;
                  true
               )
            ).
      },
      'data.list':reverse_iter(Modules) [Compiler] {
         do(Module) :-
            Compiler:queue(Module, cmdline).
      },
      Compiler:(         
         compile_all,
         generate_pl(BaseFilename, Output)
      ).      
}
