module 'emop.message' { 
   position_text(Pb, Pe, Text) :-
      Pb = pos(Filename0, Off0, Line0, BOL0),
      Pe = pos(Filename1, Off1, Line1, BOL1),
      (
         Filename0 = Filename1
      ->
         true
      ;
         throw(error_across_two_files)
      ),
      'data.number':succ(Line0, SLine0),
      'data.number':'-'(Off0, BOL0, C0),
      'data.number':'-'(Off1, BOL1, C1),
      (
         Filename0 = ''
      ->
         (
            Line0 = Line1
         ->
            'data.atom':format(
               'Line ~d, from character ~d to ~d',
               [SLine0, C0, C1],
               Text
            )
         ;
            'data.number':succ(Line1, SLine1),
            'data.atom':format(
               'From line ~d character ~d to line ~d character ~d',
               [SLine0, C0, SLine1, C1],
               Text
            )
         )
      ;
         (
            Line0 = Line1
         ->
            'data.atom':format(
               'line ~d, from character ~d to ~d',
               [SLine0, C0, C1],
               LineText
            )
         ;
            'data.number':succ(Line1, SLine1),
            'data.atom':format(
               'from line ~d character ~d to line ~d character ~d',
               [SLine0, C0, SLine1, C1],
               LineText
            )
         ),
         'data.atom':format('File "~a", ~a', [Filename0, LineText], Text)
      ).

   format(cmdline, Message, Kind) :-
      'io.err':format('[~a] ~a\n', [Kind, Message]).

   format(file(File), Message, Kind) :-
      'io.err':format('File ~a:\n[~a] ~a\n\n', [File, Kind, Message]).

   format(file(Pb, Pe), Message, Kind) :-
      'io.err':format(
         '~a:\n[~a] ~a\n\n',
         [
            'emop.message':position_text(Pb, Pe),
            Kind,
            Message
         ]
      ).

   error(Error) :-
      (
         Error = error(Message, Pos),
         'emop.message':format(Pos, Message, error)
      ->
         true
      ;
         'io.err':format('\n[exception] ~p\n\n', [Error])
      ).

   warning(Message, Pos) :-
      'emop.message':format(Pos, Message, warning).
}
