module 'io.file' {
   open_read(Filename, Stream) :-
      'kernel':io_open_read(Filename, X),
      module Stream [X] {
         read(C) :-
            'kernel':io_read(X, C).

         close :-
            'kernel':io_close(X).
      }.

   open_write(Filename, Stream) :-
      'kernel':io_open_write(Filename, X),
      module Stream [X] {
         write(C) :-
            'kernel':io_write(X, C).

         flush :-
            'kernel':io_flush(X).

         print(Term) :-
            'kernel':io_print(X, Term).

         print_endline(Term) :-
            'kernel':io_print_endline(X, Term).

         format(Format, Args) :-
            'kernel':io_format(X, Format, Args).

         close :-
            'kernel':io_close(X).
      }.

}
